// src/backend/policies_gatekeeper.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef POLICIES_GATEKEEPER_HH
#define POLICIES_GATEKEEPER_HH 1

namespace sgpem
{
  class PolicyManager;
  class Policy;
}

#include "config.h"

#include <vector>

namespace sgpem
{
  class PoliciesGatekeeper;

  /**	\brief FIXME document me 


   */

  class PoliciesGatekeeper
  {
  public:
    /** \brief Returns the unique instance of this class, conforming to the Singleton pattern.
     * 
     * \return the unique instance of this class, conforming to the Singleton pattern.
     */
    static PoliciesGatekeeper&	    get_instance();

    std::vector<PolicyManager*>	    get_registered() const;

    /** FIXME what to do when the manager was already registered? should we throw an exception?
     *
     */
    void			    register_manager(PolicyManager* manager);

    /** FIXME what to do when the manager wasn't already registered? should we throw an exception?
     *
     */
    void			    unregister_manager(PolicyManager* manager);

    Policy*			    get_current_policy();

    void			    activate_policy(Policy* policy);
    
  private:
    PoliciesGatekeeper();					//private constructor.
    static PoliciesGatekeeper*      _instance;
    std::vector<PolicyManager*>	    _registered;
    Policy* _cur_policy;
  };

}//~ namespace sgpem

#endif //POLICIES_GATEKEEPER_HH

